diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/lmc/lmc_proto.c linux-2.5/drivers/net/wan/lmc/lmc_proto.c
--- bk-linus/drivers/net/wan/lmc/lmc_proto.c	2002-11-21 02:17:18.000000000 +0000
+++ linux-2.5/drivers/net/wan/lmc/lmc_proto.c	2002-11-21 18:00:04.000000000 +0000
@@ -254,6 +254,7 @@ void lmc_proto_netif(lmc_softc_t *sc, st
     case LMC_PPP:
     case LMC_NET:
     default:
+        skb->dev->last_rx = jiffies;
         netif_rx(skb);
         break;
     case LMC_RAW:
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/sdla_chdlc.c linux-2.5/drivers/net/wan/sdla_chdlc.c
--- bk-linus/drivers/net/wan/sdla_chdlc.c	2002-11-21 02:17:15.000000000 +0000
+++ linux-2.5/drivers/net/wan/sdla_chdlc.c	2002-11-21 18:00:01.000000000 +0000
@@ -2219,6 +2219,7 @@ static void rx_intr (sdla_t* card)
                 skb->dev = dev;
                 skb->mac.raw  = skb->data;
                 netif_rx(skb);
+                dev->last_rx = jiffies;
 	}
 
 rx_exit:
@@ -3276,6 +3277,7 @@ dflt_1:
 	    		new_skb->mac.raw  = new_skb->data;
 	
 			netif_rx(new_skb);
+			dev->last_rx = jiffies;
 		} else {
 	    	
 			printk(KERN_INFO "%s: no socket buffers available!\n",
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/lapbether.c linux-2.5/drivers/net/wan/lapbether.c
--- bk-linus/drivers/net/wan/lapbether.c	2002-11-21 02:17:14.000000000 +0000
+++ linux-2.5/drivers/net/wan/lapbether.c	2002-11-21 18:00:00.000000000 +0000
@@ -186,6 +186,7 @@ static int lapbeth_data_indication(void 
 	skb->mac.raw  = skb->data;
 	skb->pkt_type = PACKET_HOST;
 
+	skb->dev->last_rx = jiffies;
 	return netif_rx(skb);
 }
 
@@ -283,6 +284,7 @@ static void lapbeth_connected(void *toke
 	skb->mac.raw  = skb->data;
 	skb->pkt_type = PACKET_HOST;
 
+	skb->dev->last_rx = jiffies;
 	netif_rx(skb);
 }
 
@@ -305,6 +307,7 @@ static void lapbeth_disconnected(void *t
 	skb->mac.raw  = skb->data;
 	skb->pkt_type = PACKET_HOST;
 
+	skb->dev->last_rx = jiffies;
 	netif_rx(skb);
 }
 
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/wanpipe_multppp.c linux-2.5/drivers/net/wan/wanpipe_multppp.c
--- bk-linus/drivers/net/wan/wanpipe_multppp.c	2002-11-21 02:17:17.000000000 +0000
+++ linux-2.5/drivers/net/wan/wanpipe_multppp.c	2002-11-21 18:00:03.000000000 +0000
@@ -1572,6 +1572,7 @@ static void rx_intr (sdla_t* card)
                 skb->dev = dev;
                 skb->mac.raw  = skb->data;
                 netif_rx(skb);
+                dev->last_rx = jiffies;
 	}
 
 rx_exit:
@@ -2175,6 +2176,7 @@ static int process_udp_mgmt_pkt(sdla_t* 
 	    		new_skb->mac.raw  = new_skb->data;
 	
 			netif_rx(new_skb);
+			dev->last_rx = jiffies;
 		} else {
 	    	
 			printk(KERN_INFO "%s: no socket buffers available!\n",
@@ -2470,6 +2472,7 @@ static void send_ppp_term_request (netde
 		new_skb->mac.raw  = new_skb->data;
 
 		netif_rx(new_skb);
+		dev->last_rx = jiffies;
 	}
 }
 
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/x25_asy.c linux-2.5/drivers/net/wan/x25_asy.c
--- bk-linus/drivers/net/wan/x25_asy.c	2002-11-21 02:17:17.000000000 +0000
+++ linux-2.5/drivers/net/wan/x25_asy.c	2002-11-21 18:00:03.000000000 +0000
@@ -250,6 +250,7 @@ static void x25_asy_bump(struct x25_asy 
 	else
 	{
 		netif_rx(skb);
+		sl->dev->last_rx = jiffies;
 		sl->rx_packets++;
 	}
 }
@@ -397,6 +398,7 @@ static int x25_asy_xmit(struct sk_buff *
   
 static int x25_asy_data_indication(void *token, struct sk_buff *skb)
 {
+	skb->dev->last_rx = jiffies;
 	return netif_rx(skb);
 }
 
@@ -449,6 +451,7 @@ static void x25_asy_connected(void *toke
 	skb->pkt_type = PACKET_HOST;
 
 	netif_rx(skb);
+	sl->dev->last_rx = jiffies;
 }
 
 static void x25_asy_disconnected(void *token, int reason)
@@ -471,6 +474,7 @@ static void x25_asy_disconnected(void *t
 	skb->pkt_type = PACKET_HOST;
 
 	netif_rx(skb);
+	sl->dev->last_rx = jiffies;
 }
 
 
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/sdla_ppp.c linux-2.5/drivers/net/wan/sdla_ppp.c
--- bk-linus/drivers/net/wan/sdla_ppp.c	2002-11-21 02:17:16.000000000 +0000
+++ linux-2.5/drivers/net/wan/sdla_ppp.c	2002-11-21 18:00:02.000000000 +0000
@@ -1897,6 +1897,7 @@ static void rx_intr(sdla_t *card)
 #endif
 		    		++ppp_priv_area->rx_intr_stat.rx_intr_bfr_passed_to_stack;	
 				netif_rx(skb);
+				dev->last_rx = jiffies;
 			}
 
 		} else {
@@ -2451,7 +2452,7 @@ static int config508(netdevice_t *dev, s
 #endif
 
 		default:
-			printk(KERN_INFO "%s: ERROR: Unsuported PPP Mode Selected\n",
+			printk(KERN_INFO "%s: ERROR: Unsupported PPP Mode Selected\n",
 					card->devname);
 			printk(KERN_INFO "%s:        PPP IP Modes: STATIC, PEER or HOST\n",
 					card->devname);	
@@ -2943,6 +2944,7 @@ udp_dflt_cmd:
             		new_skb->dev = dev;
 	    		new_skb->mac.raw  = new_skb->data;
 			netif_rx(new_skb);
+			dev->last_rx = jiffies;
 		
 		} else {
 	    	
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/syncppp.c linux-2.5/drivers/net/wan/syncppp.c
--- bk-linus/drivers/net/wan/syncppp.c	2002-11-21 02:17:17.000000000 +0000
+++ linux-2.5/drivers/net/wan/syncppp.c	2002-11-21 18:00:03.000000000 +0000
@@ -275,6 +275,7 @@ invalid:        if (sp->pp_flags & PP_DE
 					printk(KERN_DEBUG "Yow an IP frame.\n");
 				skb->protocol=htons(ETH_P_IP);
 				netif_rx(skb);
+				dev->last_rx = jiffies;
 				return;
 			}
 			break;
@@ -284,6 +285,7 @@ invalid:        if (sp->pp_flags & PP_DE
 			if (sp->lcp.state == LCP_STATE_OPENED) {
 				skb->protocol=htons(ETH_P_IPX);
 				netif_rx(skb);
+				dev->last_rx = jiffies;
 				return;
 			}
 			break;
@@ -311,12 +313,14 @@ invalid:        if (sp->pp_flags & PP_DE
 		case ETH_P_IP:
 			skb->protocol=htons(ETH_P_IP);
 			netif_rx(skb);
+			dev->last_rx = jiffies;
 			return;
 #endif
 #ifdef CONFIG_IPX
 		case ETH_P_IPX:
 			skb->protocol=htons(ETH_P_IPX);
 			netif_rx(skb);
+			dev->last_rx = jiffies;
 			return;
 #endif
 		}
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/net/wan/sdla_fr.c linux-2.5/drivers/net/wan/sdla_fr.c
--- bk-linus/drivers/net/wan/sdla_fr.c	2002-11-21 02:17:16.000000000 +0000
+++ linux-2.5/drivers/net/wan/sdla_fr.c	2002-11-21 18:00:02.000000000 +0000
@@ -2357,6 +2352,7 @@ static void rx_intr (sdla_t* card)
 		
 
 		/* Send a packed up the IP stack */
+		skb->dev->last_rx = jiffies;
 		netif_rx(skb);
 		++chan->drvstats_rx_intr.rx_intr_bfr_passed_to_stack;
 		++chan->ifstats.rx_packets;
